package splash_screen_on_boot.java;

import javafx.concurrent.Task;
import javafx.concurrent.WorkerStateEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

import java.io.IOException;

/**
 * SplashScreenOnBootController starts the entry point into meerkat it displays the loading
 */
public class SplashScreenOnBootController {
    private static final String SPALSH_SCREEN_ON_BOOT_FXML_PATH = "../fxml/spalsh_screen_on_boot.fxml";
    private static final int TWO_SECONDS_TIMEOUT_IN_MILLISECONDS = 2000;

    protected Parent SplashScreenOnBootRoot;

    public SplashScreenOnBootController(Stage primaryStage) throws IOException
    {
        SplashScreenOnBootRoot = FXMLLoader.load(getClass().getResource(SPALSH_SCREEN_ON_BOOT_FXML_PATH));
        primaryStage.setScene(new Scene(SplashScreenOnBootRoot, 565, 365));
        IntroSleep();
    }

    /**
     * After the splash screen displayed wait -
     * two seconds and than continue to StartUploadingToBulletinBoard
     */
    private void IntroSleep()
    {
        Task<Void> sleeper = new Task<Void>() {
            @Override
            protected Void call() throws Exception {
                try {
                    Thread.sleep(TWO_SECONDS_TIMEOUT_IN_MILLISECONDS);
                } catch (InterruptedException e) {
                }
                return null;
            }
        };
        sleeper.setOnSucceeded(event -> StartUploadingToBulletinBoard());
        new Thread(sleeper).start();
    }

    /**
     * Creates instance of uploading to bulletin board and set it as the scene
     */
    private void StartUploadingToBulletinBoard()
    {

    }

    /**
     * Needed for normal output fllow
     */
    public SplashScreenOnBootController(){}

}
